diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-remote-station-manager.cc ns-3.41/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.40/src/wifi/model/wifi-remote-station-manager.cc	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-remote-station-manager.cc	2024-02-09 14:44:08.605795100 -0800
@@ -71,9 +71,9 @@
                           "If the size of the PSDU is bigger than this value, we use an RTS/CTS "
                           "handshake before sending the data frame."
                           "This value will not have any effect on some rate control algorithms.",
-                          UintegerValue(65535),
+                          UintegerValue(4692480),
                           MakeUintegerAccessor(&WifiRemoteStationManager::SetRtsCtsThreshold),
-                          MakeUintegerChecker<uint32_t>())
+                          MakeUintegerChecker<uint32_t>(0, 4692480))
             .AddAttribute(
                 "FragmentationThreshold",
                 "If the size of the PSDU is bigger than this value, we fragment it such that the "
@@ -100,7 +100,8 @@
                           "Protection mode used when non-ERP STAs are connected to an ERP AP: "
                           "Rts-Cts or Cts-To-Self",
                           EnumValue(WifiRemoteStationManager::CTS_TO_SELF),
-                          MakeEnumAccessor(&WifiRemoteStationManager::m_erpProtectionMode),
+                          MakeEnumAccessor<WifiRemoteStationManager::ProtectionMode>(
+                              &WifiRemoteStationManager::m_erpProtectionMode),
                           MakeEnumChecker(WifiRemoteStationManager::RTS_CTS,
                                           "Rts-Cts",
                                           WifiRemoteStationManager::CTS_TO_SELF,
@@ -109,7 +110,8 @@
                           "Protection mode used when non-HT STAs are connected to a HT AP: Rts-Cts "
                           "or Cts-To-Self",
                           EnumValue(WifiRemoteStationManager::CTS_TO_SELF),
-                          MakeEnumAccessor(&WifiRemoteStationManager::m_htProtectionMode),
+                          MakeEnumAccessor<WifiRemoteStationManager::ProtectionMode>(
+                              &WifiRemoteStationManager::m_htProtectionMode),
                           MakeEnumChecker(WifiRemoteStationManager::RTS_CTS,
                                           "Rts-Cts",
                                           WifiRemoteStationManager::CTS_TO_SELF,
@@ -142,6 +144,8 @@
       m_shortSlotTimeEnabled(false)
 {
     NS_LOG_FUNCTION(this);
+    m_ssrc.fill(0);
+    m_slrc.fill(0);
 }
 
 WifiRemoteStationManager::~WifiRemoteStationManager()
@@ -166,13 +170,6 @@
     // transmit rate for automatic control responses like
     // acknowledgments.
     m_wifiPhy = phy;
-    m_defaultTxMode = phy->GetDefaultMode();
-    NS_ASSERT(m_defaultTxMode.IsMandatory());
-    if (GetHtSupported())
-    {
-        m_defaultTxMcs = HtPhy::GetHtMcs(0);
-    }
-    Reset();
 }
 
 void
@@ -182,7 +179,6 @@
     // We need to track our MAC because it is the object that knows the
     // full set of interframe spaces.
     m_wifiMac = mac;
-    Reset();
 }
 
 int64_t
@@ -701,13 +697,13 @@
 }
 
 WifiTxVector
-WifiRemoteStationManager::GetRtsTxVector(Mac48Address address)
+WifiRemoteStationManager::GetRtsTxVector(Mac48Address address, uint16_t allowedWidth)
 {
-    NS_LOG_FUNCTION(this << address);
+    NS_LOG_FUNCTION(this << address << allowedWidth);
+    WifiTxVector v;
     if (address.IsGroup())
     {
         WifiMode mode = GetNonUnicastMode();
-        WifiTxVector v;
         v.SetMode(mode);
         v.SetPreambleType(
             GetPreambleForTransmission(mode.GetModulationClass(), GetShortPreambleEnabled()));
@@ -717,9 +713,31 @@
         v.SetNTx(GetNumberOfAntennas());
         v.SetNss(1);
         v.SetNess(0);
-        return v;
     }
-    return DoGetRtsTxVector(Lookup(address));
+    else
+    {
+        v = DoGetRtsTxVector(Lookup(address));
+    }
+    auto modulation = v.GetModulationClass();
+
+    if (allowedWidth >= 40 &&
+        (modulation == WIFI_MOD_CLASS_DSSS || modulation == WIFI_MOD_CLASS_HR_DSSS))
+    {
+        // RTS must be sent in a non-HT duplicate PPDU because it must protect a frame being
+        // transmitted on at least 40 MHz. Change the modulation class to ERP-OFDM and the rate
+        // to 6 Mbps
+        v.SetMode(ErpOfdmPhy::GetErpOfdmRate6Mbps());
+        modulation = v.GetModulationClass();
+    }
+    // do not set allowedWidth as the TX width if the modulation class is (HR-)DSSS (allowedWidth
+    // may be >= 40 MHz) or allowedWidth is 22 MHz (the selected modulation class may be OFDM)
+    if (modulation != WIFI_MOD_CLASS_DSSS && modulation != WIFI_MOD_CLASS_HR_DSSS &&
+        allowedWidth != 22)
+    {
+        v.SetChannelWidth(allowedWidth);
+    }
+
+    return v;
 }
 
 WifiTxVector
@@ -1431,6 +1449,8 @@
 WifiRemoteStationManager::Lookup(Mac48Address address) const
 {
     NS_LOG_FUNCTION(this << address);
+    NS_ASSERT(!address.IsGroup());
+    NS_ASSERT(address != m_wifiMac->GetAddress());
     auto stationIt = m_stations.find(address);
 
     if (stationIt != m_stations.end())
@@ -1675,13 +1695,16 @@
 WifiMode
 WifiRemoteStationManager::GetDefaultMode() const
 {
-    return m_defaultTxMode;
+    NS_ASSERT(m_wifiPhy);
+    auto defaultTxMode = m_wifiPhy->GetDefaultMode();
+    NS_ASSERT(defaultTxMode.IsMandatory());
+    return defaultTxMode;
 }
 
 WifiMode
 WifiRemoteStationManager::GetDefaultMcs() const
 {
-    return m_defaultTxMcs;
+    return HtPhy::GetHtMcs0();
 }
 
 WifiMode
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-remote-station-manager.h ns-3.41/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.40/src/wifi/model/wifi-remote-station-manager.h	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-remote-station-manager.h	2024-02-09 14:44:08.605795100 -0800
@@ -816,11 +816,12 @@
     WifiTxVector GetDataTxVector(const WifiMacHeader& header, uint16_t allowedWidth);
     /**
      * \param address remote address
+     * \param allowedWidth the allowed width in MHz for the data frame being protected
      *
      * \return the TXVECTOR to use to send the RTS prior to the
      *         transmission of the data packet itself.
      */
-    WifiTxVector GetRtsTxVector(Mac48Address address);
+    WifiTxVector GetRtsTxVector(Mac48Address address, uint16_t allowedWidth);
     /**
      * Return a TXVECTOR for the CTS frame given the destination and the mode of the RTS
      * used by the sender.
@@ -1490,9 +1491,6 @@
     StationStates m_states; //!< States of known stations
     Stations m_stations;    //!< Information for each known stations
 
-    WifiMode m_defaultTxMode; //!< The default transmission mode
-    WifiMode m_defaultTxMcs;  //!< The default transmission modulation-coding scheme (MCS)
-
     uint32_t m_maxSsrc;                //!< Maximum STA short retry count (SSRC)
     uint32_t m_maxSlrc;                //!< Maximum STA long retry count (SLRC)
     uint32_t m_rtsCtsThreshold;        //!< Threshold for RTS/CTS
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-tx-vector.cc ns-3.41/src/wifi/model/wifi-tx-vector.cc
--- ns-3.40/src/wifi/model/wifi-tx-vector.cc	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-tx-vector.cc	2024-02-09 14:44:08.609795000 -0800
@@ -123,11 +123,6 @@
     }
 }
 
-WifiTxVector::~WifiTxVector()
-{
-    m_muUserInfos.clear();
-}
-
 bool
 WifiTxVector::GetModeInitialized() const
 {
@@ -451,7 +446,7 @@
 }
 
 bool
-WifiTxVector::IsValid() const
+WifiTxVector::IsValid(WifiPhyBand band) const
 {
     if (!GetModeInitialized())
     {
@@ -522,6 +517,16 @@
             return false;
         }
     }
+
+    if (band != WIFI_PHY_BAND_UNSPECIFIED)
+    {
+        NS_ABORT_MSG_IF(GetModulationClass() == WIFI_MOD_CLASS_OFDM && band == WIFI_PHY_BAND_2_4GHZ,
+                        "Cannot use OFDM modulation class in the 2.4 GHz band");
+        NS_ABORT_MSG_IF(GetModulationClass() == WIFI_MOD_CLASS_ERP_OFDM &&
+                            band != WIFI_PHY_BAND_2_4GHZ,
+                        "ERP-OFDM modulation class can only be used in the 2.4 GHz band");
+    }
+
     return true;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-tx-vector.h ns-3.41/src/wifi/model/wifi-tx-vector.h
--- ns-3.40/src/wifi/model/wifi-tx-vector.h	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-tx-vector.h	2024-02-09 14:44:08.609795000 -0800
@@ -22,6 +22,7 @@
 #define WIFI_TX_VECTOR_H
 
 #include "wifi-mode.h"
+#include "wifi-phy-band.h"
 #include "wifi-phy-common.h"
 
 #include "ns3/he-ru.h"
@@ -114,7 +115,6 @@
         HeMuUserInfoMap;
 
     WifiTxVector();
-    ~WifiTxVector();
     /**
      * Create a TXVECTOR with the given parameters.
      *
@@ -357,10 +357,13 @@
      * The standard disallows certain combinations of WifiMode, number of
      * spatial streams, and channel widths.  This method can be used to
      * check whether this WifiTxVector contains an invalid combination.
+     * If a PHY band is specified, it is checked that the PHY band is appropriate for
+     * the modulation class of the TXVECTOR, in case the latter is OFDM or ERP-OFDM.
      *
+     * \param band the PHY band
      * \return true if the WifiTxVector parameters are allowed by the standard
      */
-    bool IsValid() const;
+    bool IsValid(WifiPhyBand band = WIFI_PHY_BAND_UNSPECIFIED) const;
     /**
      * \return true if this TX vector is used for a multi-user (OFDMA and/or MU-MIMO) transmission
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/channel-access-manager-test.cc ns-3.41/src/wifi/test/channel-access-manager-test.cc
--- ns-3.40/src/wifi/test/channel-access-manager-test.cc	2023-09-27 13:30:37.922839900 -0700
+++ ns-3.41/src/wifi/test/channel-access-manager-test.cc	2024-02-09 14:44:08.609795000 -0800
@@ -806,11 +806,12 @@
                                                     uint64_t expectedGrantTime,
                                                     Ptr<TxopTest<TxopType>> state)
 {
-    if (m_ChannelAccessManager->NeedBackoffUponAccess(state))
+    auto hadFramesToTransmit = state->HasFramesToTransmit(SINGLE_LINK_OP_ID);
+    state->QueueTx(txTime, expectedGrantTime);
+    if (m_ChannelAccessManager->NeedBackoffUponAccess(state, hadFramesToTransmit, true))
     {
         state->GenerateBackoff(0);
     }
-    state->QueueTx(txTime, expectedGrantTime);
     m_ChannelAccessManager->RequestAccess(state);
 }
 
@@ -1397,7 +1398,7 @@
                              : ((1 << (busyChannel - 1)) * 20);
 
     Time checkTime1 = start + ccaBusyStartDelay + ccaBusyDuration / 2;
-    Simulator::Schedule(checkTime1 - start, [=]() {
+    Simulator::Schedule(checkTime1 - start, [=, this]() {
         Time interval1 = (ccaBusyStartDelay + ccaBusyDuration) / 2;
         NS_TEST_EXPECT_MSG_EQ(m_cam->GetLargestIdlePrimaryChannel(interval1, checkTime1),
                               idleWidth,
@@ -1410,7 +1411,7 @@
     // same as the previous case
     Time ccaBusyRxInterval = MilliSeconds(1);
     Time checkTime2 = start + ccaBusyStartDelay + ccaBusyDuration + ccaBusyRxInterval / 2;
-    Simulator::Schedule(checkTime2 - start, [=]() {
+    Simulator::Schedule(checkTime2 - start, [=, this]() {
         Time interval2 = (ccaBusyDuration + ccaBusyRxInterval) / 2;
         NS_TEST_EXPECT_MSG_EQ(m_cam->GetLargestIdlePrimaryChannel(interval2, checkTime2),
                               idleWidth,
@@ -1429,7 +1430,7 @@
     // At RX end, we check the status of the channel during an interval immediately
     // preceding RX start and overlapping the CCA_BUSY period.
     Time checkTime3 = start + ccaBusyStartDelay + ccaBusyDuration + ccaBusyRxInterval + rxDuration;
-    Simulator::Schedule(checkTime3 - start, [=]() {
+    Simulator::Schedule(checkTime3 - start, [=, this]() {
         Time interval3 = ccaBusyDuration / 2 + ccaBusyRxInterval;
         Time end3 = checkTime3 - rxDuration;
         NS_TEST_EXPECT_MSG_EQ(m_cam->GetLargestIdlePrimaryChannel(interval3, end3),
@@ -1443,7 +1444,7 @@
     // At RX end, we check the status of the channel during the interval following
     // the CCA_BUSY period and preceding RX start. The entire operating channel is idle.
     const Time& checkTime4 = checkTime3;
-    Simulator::Schedule(checkTime4 - start, [=]() {
+    Simulator::Schedule(checkTime4 - start, [=, this]() {
         const Time& interval4 = ccaBusyRxInterval;
         Time end4 = checkTime4 - rxDuration;
         NS_TEST_EXPECT_MSG_EQ(m_cam->GetLargestIdlePrimaryChannel(interval4, end4),
@@ -1458,7 +1459,7 @@
     // overlap the RX period
     Time interval5 = MilliSeconds(1);
     Time checkTime5 = checkTime4 + interval5;
-    Simulator::Schedule(checkTime5 - start, [=]() {
+    Simulator::Schedule(checkTime5 - start, [=, this]() {
         NS_TEST_EXPECT_MSG_EQ(m_cam->GetLargestIdlePrimaryChannel(interval5, checkTime5),
                               chWidth,
                               "Incorrect width of the idle channel in an interval "
@@ -1468,7 +1469,7 @@
 
     // After RX end, no channel is idle if the interval overlaps the RX period
     const Time& checkTime6 = checkTime5;
-    Simulator::Schedule(checkTime6 - start, [=]() {
+    Simulator::Schedule(checkTime6 - start, [=, this]() {
         Time interval6 = interval5 + rxDuration / 2;
         NS_TEST_EXPECT_MSG_EQ(m_cam->GetLargestIdlePrimaryChannel(interval6, checkTime6),
                               0,
@@ -1492,7 +1493,7 @@
 
         for (const auto busyChannel : busyChannels)
         {
-            Simulator::Schedule(Seconds(delay), [this, chWidth, busyChannel]() {
+            Simulator::Schedule(Seconds(delay), [=, this]() {
                 // reset PHY
                 if (m_phy)
                 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.41/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.40/src/wifi/test/spectrum-wifi-phy-test.cc	2023-09-27 13:30:37.922839900 -0700
+++ ns-3.41/src/wifi/test/spectrum-wifi-phy-test.cc	2024-02-09 14:44:08.609795000 -0800
@@ -366,7 +366,7 @@
   private:
     void DoSetup() override;
     void DoRun() override;
-    TestPhyListener* m_listener; ///< listener
+    std::shared_ptr<TestPhyListener> m_listener; ///< listener
 };
 
 SpectrumWifiPhyListenerTest::SpectrumWifiPhyListenerTest()
@@ -382,7 +382,7 @@
 SpectrumWifiPhyListenerTest::DoSetup()
 {
     SpectrumWifiPhyBasicTest::DoSetup();
-    m_listener = new TestPhyListener;
+    m_listener = std::make_shared<TestPhyListener>();
     m_phy->RegisterListener(m_listener);
 }
 
@@ -403,7 +403,7 @@
     NS_TEST_ASSERT_MSG_EQ(m_listener->m_notifyRxEndOk, 1, "Didn't receive NotifyRxEnd");
 
     Simulator::Destroy();
-    delete m_listener;
+    m_listener.reset();
 }
 
 /**
@@ -635,7 +635,7 @@
                                                                         WIFI_STANDARD_80211ax,
                                                                         WIFI_PHY_BAND_5GHZ));
     m_txPhy->SetOperatingChannel(
-        WifiPhy::ChannelTuple{txChannelNum, m_txChannelWidth, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{txChannelNum, m_txChannelWidth, WIFI_PHY_BAND_5GHZ, 0});
 
     uint16_t rxFrequency;
     switch (m_rxChannelWidth)
@@ -660,7 +660,7 @@
                                                                         WIFI_STANDARD_80211ax,
                                                                         WIFI_PHY_BAND_5GHZ));
     m_rxPhy->SetOperatingChannel(
-        WifiPhy::ChannelTuple{rxChannelNum, m_rxChannelWidth, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{rxChannelNum, m_rxChannelWidth, WIFI_PHY_BAND_5GHZ, 0});
 
     m_ruBands.clear();
     for (uint16_t bw = 160; bw >= 20; bw = bw / 2)
@@ -893,7 +893,7 @@
     std::vector<Ptr<MultiModelSpectrumChannel>> m_spectrumChannels; //!< Spectrum channels
     std::vector<Ptr<SpectrumWifiPhy>> m_txPhys{};                   //!< TX PHYs
     std::vector<Ptr<SpectrumWifiPhy>> m_rxPhys{};                   //!< RX PHYs
-    std::vector<std::unique_ptr<TestPhyListener>> m_listeners{};    //!< listeners
+    std::vector<std::shared_ptr<TestPhyListener>> m_listeners{};    //!< listeners
 
     std::vector<uint32_t> m_counts{0}; //!< count number of packets received by PHYs
 
@@ -1156,8 +1156,8 @@
             "PhyRxBegin",
             MakeCallback(&SpectrumWifiPhyMultipleInterfacesTest::RxCallback, this).Bind(index));
 
-        auto listener = std::make_unique<TestPhyListener>();
-        rxPhy->RegisterListener(listener.get());
+        auto listener = std::make_shared<TestPhyListener>();
+        rxPhy->RegisterListener(listener);
         m_listeners.push_back(std::move(listener));
 
         m_rxPhys.push_back(rxPhy);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/tx-duration-test.cc ns-3.41/src/wifi/test/tx-duration-test.cc
--- ns-3.40/src/wifi/test/tx-duration-test.cc	2023-09-27 13:30:37.922839900 -0700
+++ ns-3.41/src/wifi/test/tx-duration-test.cc	2024-02-09 14:44:08.609795000 -0800
@@ -591,7 +591,8 @@
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(8208 + 192));
 
-    // values from http://mailman.isi.edu/pipermail/ns-developers/2009-July/006226.html
+    // values from
+    // https://web.archive.org/web/20100711002639/http://mailman.isi.edu/pipermail/ns-developers/2009-July/006226.html
     retval = retval && CheckTxDuration(14,
                                        DsssPhy::GetDsssRate1Mbps(),
                                        22,
